#version 310 es
#extension GL_ANDROID_extension_pack_es31a : enable

precision highp float;

// INPUT
layout(location = 0) in vec2 a_vPosition; // In BaseShader
layout(location = 1) in vec2 a_vTexCoord; // In SceneColorShader

// OUTPUT
out vec2 v_vTexcoord;
out vec4 v_vPosWorldSpace;
out vec4 v_vPosEyeSpace;

// UNIFORMS
layout(binding=0) uniform ProjBlock {
	mat4 u_mProjectionMatrix;
	mat4 u_mInverseProjMatrix;
	mat4 u_mViewMatrix;
	mat4 u_mInverseViewMatrix;
};

layout(binding=1) uniform LightingBlock {
	vec4 u_vLightPosition;  
	vec4 u_vLightAmbient;   
	vec4 u_vLightDiffuse;   
	float u_fCausticOffset;
	float u_fCausticTiling;
};

void main()
{
    float size = 100.0f;
    float y = 0.0f;
	float tiling = 0.1f;

    v_vPosWorldSpace = vec4(a_vPosition.x * size, 0.0, a_vPosition.y * size, 1.0f) + u_mInverseViewMatrix[3];
	v_vPosWorldSpace.y = y;
    v_vPosWorldSpace.w = 1.0f;

	v_vTexcoord = (v_vPosWorldSpace.zx + a_vTexCoord)  * tiling;

    v_vPosEyeSpace = u_mViewMatrix * vec4(v_vPosWorldSpace.xyz, 1.0);
    gl_Position = u_mProjectionMatrix * v_vPosEyeSpace;
}
