#version 310 es
#extension GL_ANDROID_extension_pack_es31a : enable

precision mediump float;

// INPUT
layout(location = 0) in vec2 a_vPosition;     // In BaseShader

// OUTPUT
out vec3 v_vCubemapCoord;

layout(binding=0) uniform ProjBlock {
	mat4 u_mProjectionMatrix;
	mat4 u_mInverseProjMatrix;
	mat4 u_mViewMatrix;
	mat4 u_mInverseViewMatrix;
};

void main()
{
    gl_Position = vec4(a_vPosition.xy, 0.9999, 1.0);
    
    // Force all depths to just inside the far clip plane. If we put z=0.9999
    // in the vertex attributes, it messes up the cube projection below.
    // Nobbling it here is easier.
    gl_Position.z = 0.9999;

    vec4 vPos = u_mInverseProjMatrix * vec4(a_vPosition.xy, -1.0, 1.0);
    vPos /= vPos.w;
    
    v_vCubemapCoord = (mat3(u_mInverseViewMatrix) * vPos.xyz);
}
